Ooker_charData = {disabled = nil }
local dookwords
local speechBubbleTimers = {};
local lastTime

function OokerOnLoad()
	ChatFrame1:AddMessage("Ooker loaded, " .. ((Ooker_charData.disabled and "but dis") or "and en") .. "abled. Blizzard's profanity filter is " ..
                            (((GetCVar("profanityFilter") == "1") and "en") or "dis") .. "abled."); 
    if (not Ooker_charData.disabled) then
        OokerBlizzFilterCheck();
    end    

    SlashCmdList["Ooker"] = OokerToggle;
    SLASH_Ooker1 = "/ooker";

    OokerFrame.channel_funcs =   {WHISPER = 0,  WHISPER_INFORM = 0,
                        BN_WHISPER = 0, BN_CONVERSATION = 0,   
                        SAY = 0,        EMOTE = 0,
                        YELL = 0,
                        PARTY = 0,      PARTY_LEADER = 0,
                        RAID = 0,       RAID_LEADER = 0, 
                        RAID_WARNING = 0,
                        INSTANCE_CHAT = 0, INSTANCE_CHAT_LEADER = 0,
                        AFK = 0,        DND = 0,
                        GUILD = 0,      OFFICER = 0,
                        CHANNEL1 = 0,   CHANNEL2 = 0, 
                        CHANNEL3 = 0,   CHANNEL4 = 0, 
                        CHANNEL5 = 0,   CHANNEL6 = 0, 
                        CHANNEL7 = 0,   CHANNEL8 = 0, 
                        CHANNEL9 = 0,   CHANNEL10 = 0}
    OokerFrame:RegisterEvent("PLAYER_ENTERING_WORLD");

    dookwords = {
        {"ook", "dook", "hork", "grook", "brokk", "doogl", "jeek", "mank", "flork", "skreek", "flikkl", "joogl", "snook"}, -- words with suffices -er, -ed, -in
        {"tik-nooker", "ook-dooglin", "blikk-jeekin", "dikkety", "dook-manker"}, -- words longer than 6 letters
        {"ikk", "ook", "jib", "tik", "nib"},
        {"derk", "dook", "jerb", "hork", "nook", "jeek", "mank", "ook",},
        {"grook", "brokk", "blikk", "kroog", "wikket"}, 
        {"doogle", "snibbet", "horker" }
    }    
    lastTime = GetTime();
end


--[[    on/off switches
        OokerToggle: turns on blizzard's profanity filter if asked to, otherwise: if on, turns off.  if off, turns on.
        OokerEnable: registers all the channels to be filtered
        OokerDisable: unregisters all the channels' ook filter
        OokerBlizzFilterCheck: prints out a message if Blizzard's profanity filter isn't on.
        Ooker 
]]--    
function OokerToggle(arg1)
    if (string.lower(arg1) == "profane") then
        SetCVar("profanityFilter","1");
        print("Blizzard's profanity filter enabled.");
        print("ooker is currently " .. ((Ooker_charData.disabled and "off") or "on"));
    elseif (Ooker_charData.disabled) then
        OokerEnable();
        Ooker_charData.disabled = nil;
        print("ooker \124cffaaaaaadookin\124r on");
        OokerBlizzFilterCheck();
    else    
        OokerDisable();
        Ooker_charData.disabled = 1;
        print("ooker !@#$ing off");
    end    
end

local function OokerEnable()
    for k,v in pairs(OokerFrame.channel_funcs) do
        if (string.sub(k,1,7) ~= "CHANNEL") then
            ChatFrame_AddMessageEventFilter("CHAT_MSG_"..k, ookChatFilter);
        end    
    end
    ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ookChatFilter);
end    

local function OokerDisable()
    for k,v in pairs(OokerFrame.channel_funcs) do
        if (string.sub(k,1,7) ~= "CHANNEL") then
            ChatFrame_RemoveMessageEventFilter("CHAT_MSG_"..k, ookChatFilter);
        end    
    end
    ChatFrame_RemoveMessageEventFilter("CHAT_MSG_CHANNEL", ookChatFilter);
end

function OokerBlizzFilterCheck()
    if (GetCVar("profanityFilter") == "0") then
        print("Ooker relies on Blizzard's profanity filter, which is currently disabled. Enable in the interface->social menu, or type: \"/ooker profane\"");
    end
end    

--[[    Functions that manage the tinting the different channels' chat filters 
        OokerTouchChannel: For channelname (pre-existing or not) creates a filter using its current color. does not (re)register filter
        ChangeChatColor: Wrapper + if channelName is pre-existing, touch up its filter function
        OnEvent: initial loading (after ui sets chat colors)
        OokerLoadChannels: creates all pre-existing channelnames' filters, and registers the filters if ooker enabled
   ]]--     
      
local function OokerTouchChannel(channelName) 
    local chan_r, chan_g, chan_b;
    local tint;
    chan_r = ChatTypeInfo[channelName].r;
    chan_g = ChatTypeInfo[channelName].g;
    chan_b = ChatTypeInfo[channelName].b;
    tint = faded_rgb_escapecode(chan_r, chan_g, chan_b);
    OokerFrame.channel_funcs[channelName] = 
    function(taboo, suffix) 
        return tinted_replace_guts(taboo, suffix, tint); 
    end    
end 

if (not orig_ChangeChatColor) then
    orig_ChangeChatColor = ChangeChatColor
end
local function ChangeChatColor(channelname, r, g, b)
    orig_ChangeChatColor(channelname, r, g, b)
    if (OokerFrame.channel_funcs[channelname]) then
        OokerTouchChannel(channelname);
    end    
end


function OokerOnEvent(self, event, ...)
    if (event == "PLAYER_ENTERING_WORLD") then
        OokerLoadChannels();
        OokerFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
    end    
end 

function OokerLoadChannels()
    local chan_r, chan_g, chan_b;
    for k,v in pairs(OokerFrame.channel_funcs) do
        if (ChatTypeInfo[k]) then
            local tint;
            chan_r = ChatTypeInfo[k].r;
            chan_g = ChatTypeInfo[k].g;
            chan_b = ChatTypeInfo[k].b;
            tint = faded_rgb_escapecode(chan_r, chan_g, chan_b);
            OokerFrame.channel_funcs[k] = 
            function(taboo, suffix) 
                return tinted_replace_guts(taboo, suffix, tint); 
            end    
        end    
    end
    if (not Ooker_charData.disabled) then 
        OokerDisable() -- to prevent duplicates
        OokerEnable()
    end    
end

--[[    Speech bubble timers
]]--
local expiration
local words
local foundBubble = nil
function OokerOnUpdate(self, elapsed)
    lastTime = lastTime + elapsed;
    for expiration,words in pairs(speechBubbleTimers) do
        if (expiration <= lastTime) then
            foundBubble = findSpeech(words[1]);
            if (foundBubble) then foundBubble:SetText(words[2]) end
            speechBubbleTimers[expiration] = nil;
        end    
    end
end


--[[    Color tweaking functions
        hue, chroma, and brightness are similar to HSL colorspace, 
        but luma (y601, y') is weighted to better match actual vision.
        for hue and chroma (~saturation), I use hexagon model instead of circular
        http://en.wikipedia.org/wiki/Luminance-Hue-Saturation#Hue_and_chroma
        
        rgb2hcy: converts from rgb to hcy'
        hcy2rgb: converts from hcy' to rgb
        fade_hcy: if the color is far enough from a nuetral color (gray), make it more gray
                  otherwise, darken it if it's bright, 
                  or brighten it if its dark  
        percent2byte: converts a float 0.0 to 1.0 to two hexdigit string (so "0B" instead of B.)          
        rgb_escapecode: converts rgb floats into the escape code required to make text that color.
        faded_rgb_escapecode: puts all of the above together, takes starting rgb color, 
                  'fades' it according to HCY', and returns as the escape code required to make text /that/ color
]]--

local function rgb2hcy (r, g, b)
    local y601 = 0.299 * r + 0.587 * g + 0.114 * b; -- luma, weighted "brightness"
    local c = math.max(r,g,b) - math.min(r,g,b); -- chroma, "saturation"
    local hh, h;
    if (c == 0) then
        hh = 0;
    elseif (r >= g and r >= b) then
        hh = (((g - b)/c)%6)
    elseif ( g >= b) then 
        hh = (b-r)/c + 2;
    else -- max->b
        hh = (r-g)/c +4;
    end
    h = 60 * hh;
    return h, c, y601;
end    

local function hcy2rgb(h, c, y601)
    local hh = h/60;
    local x = c *(1-math.abs(hh%2 - 1))
    local rr,gg,bb;
    if (hh < 1) then
        rr,gg,bb = c,x,0;
    elseif (hh < 2) then
        rr,gg,bb = x,c,0;
    elseif (hh < 3) then
        rr,gg,bb = 0,c,x;
    elseif (hh < 4) then
        rr,gg,bb = 0,x,c;
    elseif (hh < 5) then
        rr,gg,bb = x,0,c;
    else --if (hh < 6) then
        rr,gg,bb = c,0,x;
    end    
    local min = y601 - (.299 * rr + 0.587 * gg + 0.114 * bb);
    return rr + min, gg + min, bb + min;
end    

local function fade_hcy(h, c, y601)
    if (c > .5) then
        return h, math.max(0,c - .45), y601;
    elseif (y601 > .9) then
        return h, c, y601 * .6;
    elseif (y601 > .4) then
        return h, c, y601-.15 ;
    else
        return h, c, y601 + .2;
    end    
end

local function percent2byte(percent)
    local byte = string.format("%x",math.min(255, math.max(0, math.floor(255*percent))));
    if string.len(byte) == 1 then byte = "0"..byte; end
    return byte;
end

local function rgb_escapecode(r, g, b)
    return string.format("\124cff%s%s%s", percent2byte(r), percent2byte(g), percent2byte(b)); --
end

function faded_rgb_escapecode(r, g, b)
    return rgb_escapecode(hcy2rgb(fade_hcy(rgb2hcy(r,g,b))))
end    

--[[    Filter function Wrappers: 
        ookChatFilter: every channel uses this, top level filter. Takes the whole message, 
                returns whole message (altered when necessary)
        gsub_ookwrapper: takes whole message, routes taboo words to apropriately tinted version of filter
                returns whole message (altered when necessary)
        tinted_replace_guts: 'virtualish' function. Each channel has its own version stored in         
                OokerFrame.channel_funcs, with 'tint' hardwired in. Takes taboo word (and potential suffix directly following it)
                returns tinted 'ooked' version of taboo word.
                
                possible suffix inclusions:
                -ing -> -in,  -ed, -er, -ers, -es, -s
                all others returned untouched.

                Hozen cusses will be approximately the same length as the original taboo word.
                Except words with "-in, -ed, -er" suffixes. And "ook" is added into length 4 as well as 3.
                Taboo words seven or longer just get hozen cusses from "long".

                There will be false positives. These functions only filter out taboo words (string of !@#$ characters)
                if they use just those characters and the first 3 are in the right order.  Most expected false positive
                is something like @#$%!!!!!, which will return a long
                hozen cuss with a single '!'.
]]--                


function ookChatFilter(chatframe, event, msg, author, arg3, arg4, arg5, arg6, arg7, chan_num, ...)
    if (strmatch(msg,"testing123")) then
        p(tostring(event).." msg:"..tostring(msg).." author:"..tostring(author).." 3:"..tostring(arg3).." 4:"..tostring(arg4).." 5:"..tostring(arg5).." 6:"..tostring(arg6).." 7:"..tostring(arg7).." N:"..tostring(chan_num))
    end    
    local chan = string.sub(event,10);
    if (chan_num > 0) then chan = chan .. tostring(chan_num); end
    local msg2 = gsub_ookwrapper(msg, chan);
    if (chan == "SAY" or chan == "YELL" or chan == "PARTY" or chan == "PARTY_LEADER") then -- channels that can do speech bubbles
        speechBubbleTimers[lastTime+.1] = {gsub(msg,"\124c.*%[(.*)%]\124h\124r","%1"),gsub(msg2,"\124c.*%[(.*)%]\124h\124r","%1")}; -- original msg and ooked text, both with links reduced to text
    end
    return false, msg2, author, arg3, arg4, arg5, arg6, arg7, chan_num, ...;
end

function gsub_ookwrapper(msg, channel) --results will be the same as gsub(msg, "!@#"..., ookwords[])
    --local function tinted_gsub = channel_funcs[channel];
    --return tinted_gsub(msg);
    if (not OokerFrame.channel_funcs[channel]) then
        if (not channel == "CHANNEL") then 
            print(tostring(channel) .. " got as a channel for Ooker, no function defined")
        end    
        return msg;
    end
    return gsub(msg,"([!@#$%%^&*][!@#$%%^&*][!@#$%%^&*]+)([%a]*)",OokerFrame.channel_funcs[channel]);
end

function tinted_replace_guts(taboo, suffix, tint)    
    local endtint = "\124r";
    local first3 = string.sub(taboo,1,3);
    local suff = suffix:lower();
    local ookword;
    if (string.sub(taboo,-1) == "!" and not string.sub(taboo,-2,-2))then
        suff = "!"..suff;
        taboo = string.sub(taboo,1,-2);
    end    

    local tabooLen = string.len(taboo);
    if (first3 == "!@#" or first3 == "@#$" or first3 == "#$%" or
        first3 == "$%^" or first3 == "%^&" or
        first3 == "^&*" or first3 == "&*!" or first3 == "*!@" ) then
        -- word has suffix
        if (suff == "ty" or suff == "ts" or suff == "tz" or suff == "tier" or suff == "tiest" or suff == "ter" or suff == "ting") then
            suff = string.sub(suff, 2, -1);
        end    
        if (suff == "ing" or suff == "en") then suff = "in" 
        elseif (suff == "es" or suff == "z") then suff = "s" 
        elseif (suff == "d") then suff = "ed"
        end
        if (suff == "ed" or suff == "er" or suff == "ers" or suff == "erz" or suff == "in") then
            ookword = dookwords[1][math.random(#dookwords[1])] .. suff;
            return tint .. ookword .. endtint;
        else
            if (tabooLen > 6) then
                tabooLen = 2;
            end    
            ookword = dookwords[tabooLen][math.random(#dookwords[tabooLen])];
            if (suff == "s") then 
                if (string.sub(ookword, -1) == "y") then
                    ookword = string.sub(ookword,1,-2) .. "ie";
                end    
                ookword = ookword .. "s"; 
                suff = "";
            elseif (suff == "est") then
                if (string.sub(ookword, -1) == "y") then
                    ookword = string.sub(ookword,1,-2) .. "i";
                end    
                ookword = ookword .. suff; 
                suff = "";
            elseif (suff == "y") then
                if (string.sub(ookword, -1) == "y") then
                    suff = "";
                elseif (string.sub(ookword,-2) == "in") then
                    suff = "ly";
                end    
                ookword = ookword .. suff; 
                suff = "";
            elseif (suff == "iest" or suff == "ier") then
                if (string.sub(ookword, -1) == "y") then
                    ookword = string.sub(ookword,1,-2);
                elseif (string.sub(ookword,-2) == "in" or string.sub(ookword,-2) == "er") then
                    suff = string.sub(suff,2);
                end    
                ookword = ookword .. suff; 
                suff = "";
            end    
            return tint .. ookword .. endtint .. suff;
        end    
    else -- false match from [!@#$%%^&*]+
        return taboo .. suff;
    end
end    

function findSpeech(msg)
    for i = 1, WorldFrame:GetNumChildren() do
        local frame = select(i, WorldFrame:GetChildren())
        if not frame:GetName() and not frame.inUse then
            for i = 1, select("#", frame:GetRegions()) do
                local region = select(i, frame:GetRegions())
                if region:GetObjectType() == "FontString" and msg == region:GetText() then
                    return region 
                end
            end

        end
    end
end
